class AntiPush extends Mutator
	config(AntiPush);

var bool init;
var config bool bNeverPushM8;
var TeamGamePlus tgp;

function PreBeginPlay()
{

	if(init)
		return;
		
	tgp = TeamGamePlus(Level.Game);
	if(tgp == None)
	{
		Log("no teamgame", 'AntiPush');
		init = True;
		Self.Destroy();
		return;
	}
		
	Level.Game.RegisterDamageMutator(Self);
	Log("--Anti-Push starting--");
	
	init = True;
}

function MutatorTakeDamage( out int ActualDamage, Pawn Victim, Pawn InstigatedBy, out Vector HitLocation, out Vector Momentum, name DamageType)
{
		
	if(InstigatedBy != None && Victim != InstigatedBy &&
		Victim.bIsPlayer && InstigatedBy.bIsPlayer &&
		Victim.PlayerReplicationInfo.Team == InstigatedBy.PlayerReplicationInfo.Team)
		{
			if(bNeverPushM8)
				Momentum = vect(0, 0, 0);
			else
				Momentum *= tgp.FriendlyFireScale;
		}


	if ( NextDamageMutator != None )
		NextDamageMutator.MutatorTakeDamage( ActualDamage, Victim, InstigatedBy, HitLocation, Momentum, DamageType );
}

defaultproperties
{
	bNeverPushM8=True
}
